Program UserPack;

Uses Dos,Crt;

type anystr=string[255];
     lstr=string[80];
     mstr=string[35];
     sstr=string[15];
     accesstype=(bylevel,keepout,letin,invalid);
     availtype=(available,bytime,notavailable);
     configtype=(lowercase,eightycols,linefeeds,postprompts,moreprompts,
                 asciigraphics,ansigraphics,udsysop,bulletinsysop,votingsysop,
                 emailsysop,doorssysop,mainsysop,databasesysop,wanted,
                 showtime,vt52,fseditor);
     groupclass=(publicgroup,privategroup,personalgroup);
	voteset=array [1..10] of byte;
     boardorder=array [0..255] of byte;
	conferenceset=array[0..32] of byte;


type userrec=record
	  handle,              (* Users Handle *)
       realname:mstr;       (* Users Real Name *)
       password:sstr;       (* Users Password *)
       phonenum:string[10]; (* Users Phone Number *)
       laston:longint;      (* Last Call date in DATEPACK form *)
       numon,               (* Total Calls *)
       timetoday,           (* Time left today *)
	  nbu,                 (* Messages posted *)
	  uploads,             (* Uploads *)
	  downloads:integer;   (* Downloads *)
	  totaltime:real;      (* Total Time spent on system by user *)
	  voted:voteset;       (* What the user voted on *)
	  udlevel,             (* File Level *)
	  udpoints,            (* File Points *)
	  level,               (* Main Access Level *)
	  emailannounce,       (* Sector for Email Announcement "-1" if none *)
	  beepedpwd,           (* Reserved *)
	  infoform,            (* Location for Infoform #1 *)
	  glevel,              (* G-File Level *)
	  gpoints:integer;     (* G-File Points *)
       regularcolor,        (* The following are the users colors. *)
       promptcolor,
       statcolor,
       inputcolor,
       displaylen,
       menuboard,
       menuback,
       blowboard,
       blowinside:byte;
       config:set of configtype;   (* Various config stuff, i.e. Ansi, etc *)
       newscanconfig,              (* Various stuff dealing with message
                                      bases. Do not mess with these. *)
       access1,
       access2:set of byte;
       usernote,                   (* Account Note [Public] *)
       macro1,                     (* Predefined user macros *)
       macro2,
       macro3:mstr;
       upkay,                      (* Upload K *)
       dnkay:longint;              (* Download K *)
       lastbaud,                   (* Last baud rate used *)
       lastlevel,                  (* Last main access level *)
       lastxfer,                   (* Last File Level *)
       lastxferpts:integer;        (* Last File Points *)
	  confset:conferenceset;      (* Array [A..Z] of byte for the
                                      sub-conferences *)
       hackattempts:integer;       (* Password Hack Attempts *)
       revision:integer;           (* Last Revision Number *)
       lastposts,                  (* Last total messages in system *)
       lastfiles:word;             (* Last total files in system *)
       infoform2,                  (* Location of Infoforms 2-5 *)
       infoform3,
       infoform4,
       infoform5:integer;
	  lastread :array [0..255] of word;        (* Message Stuff *)
	  expdate  :longint;             (* Expiration date in DATEPACK form *)
	  timebank :integer;            (* Time stored in Time Bank *)
       lastcalno:word;              (* Last Caller Number *)
       udratio,                     (* Individual Upload/Download Ratio *)
       udkratio,                    (* Individual U/D K Ratio *)
       pcratio:integer;             (* Individual Post/Call Ratio *)
	  avatar :byte;                 (* 0=Normal ansi, 1=Pull Down Windows,
                                       2=Avatar (not implemented yet) *)
       timelimits:integer;          (* Daily time limit (0 means normal) *)
       Conf:Array [1..5] of Boolean;   (* Main Conference Flags *)
       LastConf:Byte;                  (* Last Conference user was in *)
	  SpecialSysopNote:Mstr;          (* Special Sysop Note *)
	  MenuHighlight,statusboxcolor:Byte;
       AutoSig:Record
          Line:Array[1..10] of String[74];
          Num:Byte;
       End;
  end;


type newrec=record
       handle,              (* Users Handle *)
       realname:mstr;       (* Users Real Name *)
       password:sstr;       (* Users Password *)
       phonenum:string[10]; (* Users Phone Number *)
       laston:longint;      (* Last Call date in DATEPACK form *)
       numon,               (* Total Calls *)
       timetoday,           (* Time left today *)
       nbu,                 (* Messages posted *)
       uploads,             (* Uploads *)
       downloads:integer;   (* Downloads *)
       totaltime:real;      (* Total Time spent on system by user *)
       voted:voteset;       (* What the user voted on *)
       udlevel,             (* File Level *)
       udpoints,            (* File Points *)
       level,               (* Main Access Level *)
       emailannounce,       (* Sector for Email Announcement "-1" if none *)
       beepedpwd,           (* Reserved *)
       infoform,            (* Location for Infoform #1 *)
	  Tlevel,              (* Terrorism Level *)
	  Tpoints:integer;     (* Terrorism Points *)
       regularcolor,        (* The following are the users colors. *)
       promptcolor,
       statcolor,
       inputcolor,
       displaylen,
       menuboard,
       menuback,
       blowboard,
       blowinside:byte;
       config:set of configtype;   (* Various config stuff, i.e. Ansi, etc *)
       newscanconfig,              (* Various stuff dealing with message
                                      bases. Do not mess with these. *)
       access1,
       access2:set of byte;
       usernote,                   (* Account Note [Public] *)
       macro1,                     (* Predefined user macros *)
       macro2,
       macro3:mstr;
       upkay,                      (* Upload K *)
       dnkay:longint;              (* Download K *)
       lastbaud,                   (* Last baud rate used *)
       lastlevel,                  (* Last main access level *)
       lastxfer,                   (* Last File Level *)
       lastxferpts:integer;        (* Last File Points *)
	  confset:conferenceset;      (* Array [A..Z] of byte for the
                                      sub-conferences *)
       hackattempts:integer;       (* Password Hack Attempts *)
       revision:integer;           (* Last Revision Number *)
       lastposts,                  (* Last total messages in system *)
       lastfiles:word;             (* Last total files in system *)
       infoform2,                  (* Location of Infoforms 2-5 *)
       infoform3,
       infoform4,
       infoform5:integer;
	  lastread :array [0..255] of word;        (* Message Stuff *)
	  expdate  :longint;             (* Expiration date in DATEPACK form *)
	  timebank :integer;            (* Time stored in Time Bank *)
       lastcalno:word;              (* Last Caller Number *)
       udratio,                     (* Individual Upload/Download Ratio *)
       udkratio,                    (* Individual U/D K Ratio *)
       pcratio:integer;             (* Individual Post/Call Ratio *)
	  avatar :byte;                 (* 0=Normal ansi, 1=Pull Down Windows,
                                       2=Avatar (not implemented yet) *)
       timelimits:integer;          (* Daily time limit (0 means normal) *)
       Conf:Array [1..5] of Boolean;   (* Main Conference Flags *)
       LastConf:Byte;                  (* Last Conference user was in *)
	  SpecialSysopNote:Mstr;          (* Special Sysop Note *)
	  MenuHighlight,statusboxcolor:Byte;
	  AutoSig:Record
           Line:Array[1..10] of String[74];
           Num:Byte;
        End;
  end;


Var
    Update:NewRec;
    Urec:Userrec;
    Old:File of Userrec;
    New:FIle of NewRec;
    Cnt:Integer;
    C:Char;
    Source,target:String;
    FFile:File;

Begin
  ClrScr;
	WriteLn('User Packing program for ShockWavE BBS ver. 1.00b');
	Writeln;
	Writeln('You might want to make a separate backup of your users!');
	Writeln('Hit ESC to quit');
  WriteLn;
  Write('[Hit A Key]'); C:=Readkey;
  If C=#27 then halt; Writeln;

  Assign(FFILE,'USERS');
  Rename(FFILE,'USERS.BAK');

  Assign(OLD,'USERS.BAK');
  Reset(OLD);

  Assign(New,'USERS.NEW');
  Rewrite(New);

While Not Eof(OLD) Do
  Begin
    Read(OLD,Urec);
    If length(urec.Handle)<=0 then seek(old,FilePos(old)) else
    Begin
	With Urec do
	Begin
	  Update.handle   :=handle;            (* Users Handle *)
	  Update.realname :=Realname;          (* Users Real Name *)
	  Update.password :=Password;          (* Users Password *)
	  Update.phonenum :=phonenum;          (* Users Phone Number *)
	  Update.laston   :=Laston;            (* Last Call date in DATEPACK form *)
	  Update.numon    :=Numon;             (* Total Calls *)
	  Update.timetoday:=Timetoday;         (* Time left today *)
	  Update.nbu      :=Nbu;               (* Messages posted *)
	  Update.uploads  :=Uploads;           (* Uploads *)
	  Update.downloads:=Downloads;         (* Downloads *)
	  Update.totaltime:=TotalTime;         (* Total Time spent on system by user *)
	  Update.voted    :=Voted;             (* What the user voted on *)
	  Update.udlevel  :=udlevel;           (* File Level *)
	  Update.udpoints :=udpoints;          (* File Points *)
	  Update.level    :=level;             (* Main Access Level *)
	  Update.emailannounce:=emailannounce; (* Sector for Email Announcement "-1" if none *)
	  Update.beepedpwd:=beepedpwd;         (* Reserved *)
	  Update.infoform :=infoform;          (* Location for Infoform #1 *)
	  Update.tlevel   :=glevel;            (* G-File Level *)
	  Update.tpoints  :=gPoints;           (* G-File Points *)
	  Update.regularcolor:=regularcolor;   (* The following are the users colors. *)
	  Update.promptcolor:=promptColor;
	  Update.statcolor:=statcolor;
	  Update.inputcolor:=inputcolor;
	  Update.displaylen:=displaylen;
	  Update.menuboard:=menuboard;
	  Update.menuback :=menuback;
	  Update.blowboard:=blowboard;
	  Update.blowinside:=blowinside;
	  Update.StatusBoxColor:=StatusBoxColor;
	  Update.config   :=config;            (* Various config stuff, i.e. Ansi, etc *)
	  Update.newscanconfig:=newscanconfig; (* Various stuff dealing with message
										  bases. Do not mess with these. *)
	  Update.access1  :=access1;
	  Update.access2  :=access2;
	  Update.usernote :=Usernote;          (* Account Note [Public] *)
	  Update.macro1   :=macro1;            (* Predefined user macros *)
	  Update.macro2   :=macro2;
	  Update.macro3   :=macro3;
	  Update.upkay    :=upkay;             (* Upload K *)
	  Update.dnkay    :=dnkay;             (* Download K *)
	  Update.lastbaud :=lastbaud;          (* Last baud rate used *)
	  Update.lastlevel:=lastlevel;         (* Last main access level *)
	  Update.lastxfer :=lastxfer;          (* Last File Level *)
	  Update.lastxferpts:=lastxferpts;     (* Last File Points *)
	  Update.confset  :=confset;           (* Array [A..Z] of byte for the
										  sub-conferences *)
	  Update.hackattempts:=hackattempts;   (* Password Hack Attempts *)
	  Update.revision :=revision;          (* Last Revision Number *)
	  Update.lastposts:=lastposts;         (* Last total messages in system *)
	  Update.lastfiles:=lastfiles;         (* Last total files in system *)
	  Update.infoform2:=infoform2;         (* Location of Infoforms 2-5 *)
	  Update.infoform3:=infoform3;
	  Update.infoform4:=infoform4;
	  Update.infoform5:=infoform5;

	  For Cnt:=1 to 255 do Update.lastread[cnt]:=lastread[cnt];
					   (* Message Stuff *)

	  Update.expdate  :=expdate;           (* Expiration date in DATEPACK form *)
	  Update.timebank :=Timebank;          (* Time stored in Time Bank *)
	  Update.lastcalno:=lastcalno;         (* Last Caller Number *)
	  Update.udratio  :=udratio;           (* Individual Upload/Download Ratio *)
	  Update.udkratio :=udkratio;          (* Individual U/D K Ratio *)
	  Update.pcratio  :=pcratio;           (* Individual Post/Call Ratio *)
	  Update.avatar   :=avatar;            (* 0=Normal ansi, 1=Pull Down Windows,
										  2=Avatar (not implemented yet) *)
	  Update.timelimits:=Timelimits;       (* Daily time limit (0 means normal) *)

	  For Cnt:=1 to 5 do Update.Conf[cnt]:=conf[cnt];
			   (* Main Conference Flags *)

	  Update.LastConf :=lastconf;          (* Last Conference user was in *)
	  Update.SpecialSysopNote:=specialsysopnote;(* Special Sysop Note *)
	  Update.MenuHighlight:=MenuHighlight;
	  for Cnt:=1 to 10 do Update.AutoSig.Line[cnt]:=Urec.Autosig.Line[cnt];
       Update.AutoSig.Num:=AutoSig.Num;
	End;

	Writeln('User#: ',filepos(old),' - ',Update.Handle);
	seek(OLD,filepos(old));

	Seek(NEW,filesize(new));
	Write(NEW,Update);

    End;
  end;

  WriteLn(^M,filepos(old),' users were upgraded.');

  Close(OLD);
  Close(new);

  Assign(FFILE,'USERS.NEW');
  Rename(FFILE,'USERS');

End.
